package cn.estsh.i3plus.ext.mes.pcn.apiservice.schedulejob;


import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesWorkOrderService;
import cn.estsh.i3plus.pojo.mes.bean.MesProduceSn;
import cn.estsh.impp.framework.boot.init.ApplicationProperties;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author castle,暂时没有客供品移库
 * @version 1.0
 * @date 2021/2/2 16:44
 **/
@Slf4j
@DisallowConcurrentExecution
@Component
@ApiOperation("非排序报工job")
public class MesReportNoSortJob extends BaseMesScheduleJob {

    @Autowired
    private IMesWorkOrderService workOrderService;

    public MesReportNoSortJob() {
        super(MesReportNoSortJob.class, "非排序报工JOB");
    }
    @Override
    public void executeMesJob(JobExecutionContext context, ApplicationProperties applicationProperties) {
        String jobParam = this.getJobParam();
        JSONObject jsonObject= JSONUtil.parseObj(jobParam);
        String organizeCode = jsonObject.getStr("organizeCode");
        String userName = jsonObject.getStr("userName");
        if (null == organizeCode){
            log.error("请添加需要报工的工厂代码!");
            return;
        }
        if (null == userName){
            userName = "JOB";
        }
        List<MesProduceSn> unReportMesProduceSn = workOrderService.getUnReportMesProduceSn(organizeCode);
        workOrderService.doProductReport(unReportMesProduceSn,organizeCode,userName);
    }
}
