package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesConfigService;
import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesJisShippingService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.pojo.mes.bean.MesJisShipping;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesShippingOrderManagement;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesShippingOrderManagementDetail;
import cn.estsh.i3plus.pojo.mes.repository.MesShippingOrderManagementDetailRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesShippingOrderManagementRepository;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author :
 * @CreateDate : 2024-05-10 14:38
 * @Modify:
 **/
@Service
@Slf4j
public class MesJisShippingService implements IMesJisShippingService {

    @Autowired
    private MesShippingOrderManagementRepository shippingOrderManagementRepository;
    @Autowired
    private MesShippingOrderManagementDetailRepository shippingOrderManagementDetailRepository;
    @Autowired
    private IMesConfigService configService;

    public List<MesJisShipping> getJisShipping(MesShippingOrderManagement orderManagement, List<MesShippingOrderManagementDetail> orderManagementDetailList, String org) {

        List<MesJisShipping> jisShippingList = new ArrayList<>();
        orderManagementDetailList.forEach(k -> {
            MesJisShipping jisShipping = new MesJisShipping();
            BeanUtils.copyProperties(orderManagement, jisShipping, "id");
            BeanUtils.copyProperties(k, jisShipping, "id");
            jisShipping.setFactoryCode(orderManagement.getCustOrganizeCode());
            jisShipping.setShippingTime(TimeTool.getNowTime(true));
            jisShipping.setErpWarerhouse(configService.getCfgValue(org, "ERP_WARERHOUSE"));
            jisShipping.setErpWarehous(configService.getCfgValue(org, "ERP_WAREHOUS"));
            jisShipping.setDock(orderManagement.getSendDockCode());
            jisShipping.setCusCode(orderManagement.getCustCode());
            jisShipping.setCusDock(orderManagement.getCustDockCode());
            jisShipping.setCustOrderNo(k.getCustOrderNo());
            jisShipping.setSerialNumber(k.getBarcode());
            jisShipping.setQuantityPerCar(1);
            jisShipping.setOffTime(TimeTool.getNowTime(true));
            jisShipping.setShippingOrderCode(orderManagement.getShippingCode());
            ConvertBean.serviceModelInitialize(jisShipping, AuthUtil.getSessionUser().getUserName());
            jisShippingList.add(jisShipping);
        });

        return jisShippingList;
    }
}
