package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.print.strategy;

import cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi.MesConfigService;
import cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.print.IPrintTemplateStrategyService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionPsOutContext;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description :
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2024/6/17 16:31
 * @Modify:
 **/
@Service
@Slf4j
public class NoSortBarCodeGzStrategy implements IPrintTemplateStrategyService {
    @Autowired
    private MesConfigService mesConfigService;
    @Override
    public Map<String, Object> execute(StationRequestBean reqBean,MesProductionPsOutContext sn, String organizeCode) {
        //获取供应商编码
        String supplierCode = mesConfigService.getCfgValue(reqBean.getOrganizeCode(), "supplierCode");
        //1.根据零件号获取 零件扩展信息
        Map<String,Object> map = new HashMap<>();
        String partNo = sn.getPartNo();
        String partName = sn.getPartName();
        String factoryName = reqBean.getOrganizeName();
        String productSn = sn.getProductSn();
        LocalDateTime now = LocalDateTime.now();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss.SSS");
        String productDateTime = now.format(formatter);

        map.put("partNo", partNo);
        map.put("partName", partName);
        map.put("factoryName", factoryName);
        map.put("supplierCode", supplierCode);
        map.put("productDate", productDateTime);
        map.put("no", productSn.substring(productSn.length()-4));
        map.put("barcode", productSn);
        return map;
    }
}
