package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.step;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesProductionDispatchContextStepService;
import cn.estsh.i3plus.mes.pcn.serviceimpl.fsm.BaseStepService;
import cn.estsh.i3plus.pojo.base.enumutil.MesPcnEnumUtil;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.model.StationResultBean;
import cn.estsh.i3plus.pojo.mes.model.StepResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Description : 完成工步
 * @Author : zxw
 **/
@Slf4j
@Service
public class MesEndStepService extends BaseStepService {


    @Autowired
    private IMesProductionDispatchContextStepService mesProductionDispatchContextStepService;

    /*
     * @param reqBean
     * @return
     */
    @Override
    public StepResult execute(StationRequestBean reqBean) {

        StationResultBean resultBean = new StationResultBean();

        StepResult stepResult = StepResult.getSuccessComplete();

        mesProductionDispatchContextStepService.deleteFirstMouldNoContext(reqBean);
        mesProductionDispatchContextStepService.deleteMouldNoContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductResultContext(reqBean);
        mesProductionDispatchContextStepService.deleteReadySignalContext(reqBean);

        mesProductionDispatchContextStepService.deleteMesRawPartChargingDataContext(reqBean);
        mesProductionDispatchContextStepService.deletePartDataContext(reqBean);
        mesProductionDispatchContextStepService.deleteProdRuleDataContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductionPartContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductionPartNoContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductionPsInContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductionPsOutContext(reqBean);
        mesProductionDispatchContextStepService.deleteScanAssemblySnContext(reqBean);
        mesProductionDispatchContextStepService.deleteSendProcessCmdContext(reqBean);
        mesProductionDispatchContextStepService.deleteScanWorkOrderNoContext(reqBean);
        mesProductionDispatchContextStepService.deleteScanProductSnContext(reqBean);

        this.sendMessage(reqBean, new StationResultBean().busiType(MesPcnEnumUtil.STATION_BUSI_TYPE.STEP_CUSTOM_CONTENT.getValue()).dataType(MesPcnEnumUtil.STATION_DATA_TYPE.TABLES.getValue()));

        return execSuccessCompleteAndSendMsgReturn(reqBean, resultBean.writeDbLog(), stepResult, "完成工步执行成功");

    }
}
